

Table table;
Table codesVdt = new Table();
byte[] trameVdt;
boolean vdtCharge = false;
boolean vdtChargeOld = false;
int nColonnes = 32;
int ligne1 = 0;

void setup() {
  size(800, 600);
  codesVdt.addColumn("vdt");
  codesVdt.addColumn("code");
  codesVdt.addColumn("nOctets");
  //trameVdt = loadBytes("data/buffet01.vdt");
  loadTex();
  //saveTable(codesVdt, "data/codesVdt.csv");
}

void draw() {
  background(255);
  if (vdtCharge && !vdtChargeOld) {
    table = loadTable("data/codes.csv", "header");
    for (int i = 0; i<table.getRowCount(); i++) {
      String [] octets = split(table.getString(i, 2), ' ');
      byte[] aiguille = new byte[octets.length];
      for (int j = 0; j<octets.length; j++) {
        aiguille[j] = byte(unhex(octets[j]));
      }
      int [] index = index(aiguille);
      for (int j = 0; j<index.length; j++) {
        TableRow newRow = codesVdt.addRow();
        newRow.setString("vdt", nf(index[j], 5));
        newRow.setString("code", table.getString(i, 1));
        if (table.getString(i, 2).equals("1F")) {
          newRow.setInt("nOctets", 3);
        } else if (table.getString(i, 2).equals("12")) {
          newRow.setInt("nOctets", 2);
        } else {
          newRow.setInt("nOctets", octets.length);
        }
      }
    }
    codesVdt.sort(0);
  }
  vdtChargeOld = vdtCharge;
  if (vdtCharge) {
    int taillePolice = 16;
    float l = taillePolice*1.5;
    
    int margeX = 30;
    int margeY = 60;
    affTrame(nColonnes, ligne1, taillePolice, margeX,margeY);
    if (mouseX>margeX && mouseX<l*nColonnes+margeX && mouseY>margeY) {
      int xVdt = floor(map(mouseX, margeX, l*nColonnes+margeX, 0, nColonnes));
      int yVdt = floor(map(mouseY, margeY, l*nColonnes+margeY, 0, nColonnes));
      int indexSouris = constrain(xVdt+nColonnes*(yVdt+ligne1), 0, trameVdt.length-1);
      TableRow resultat = codesVdt.findRow(nf(indexSouris, 5), 0);
      float xAff=map(xVdt, 0, nColonnes, margeX, l*nColonnes+margeX);
      float yAff=map(yVdt, 0, nColonnes, margeY, l*nColonnes+margeY);
      if (resultat != null) {
        noFill();
        stroke(255, 0, 0);
        rect(xAff, yAff, l*resultat.getInt(2)-5, l-5);
        fill(255, 0, 0);
        textAlign(LEFT, TOP);
        textSize(margeX/2);
        if (resultat.getString(1).equals("Positionnement curseur")){
          text(indexSouris + " " + resultat.getString(1)+ "  x=" + (trameVdt[indexSouris + 2]-64)+ "  y=" + (trameVdt[indexSouris + 1]-64) , margeX/2, 5 );
        }
        else{
        text(indexSouris + " " + resultat.getString(1), margeX/2, 5);
        }
        
      } else {
        noFill();
        stroke(0, 255, 0);
        rect(xAff, yAff, l-5, l-5);
        fill(0, 255, 0);
        textAlign(LEFT, TOP);
        textSize(margeX/2);
        if (quelJeu(indexSouris) == 0) {
          text(indexSouris + " " + char(trameVdt[indexSouris]), margeX/2, 5);
        } else {
          text(indexSouris, margeX/2, 5);
          affCharG1(trameVdt[indexSouris], byte(7), byte(0), 50, 5, int(2*l/3), int(l));
        }
      }
    }
  }
}

void keyPressed(){
   if (key == CODED) {
    if (keyCode == UP) {
      ligne1--;
    } else if (keyCode == DOWN) {
      ligne1++;
    } 
    ligne1 = constrain(ligne1,0,trameVdt.length/nColonnes - 1);
  }
}

void mouseWheel(MouseEvent event) {
  int e = event.getCount();
  ligne1 += e;
  ligne1 = constrain(ligne1,0,trameVdt.length/nColonnes - 1);
}


int quelJeu(int index) {
  int jeu = 0;
  for (int i = index; i>-1; i--) {
    if (trameVdt[i] == 14 || trameVdt[i] == 15 || trameVdt[i] == 31) {
      if (trameVdt[i] == 14) {
        jeu = 1;
      }
      if (trameVdt[i] == 15 || trameVdt[i] == 31) {
        jeu = 0;
      }
      i=-1;
    }
  }
  return jeu;
}

int[] index(byte[] aiguille) {
  int[] indexTemp = new int[1000];
  int k=0;
  for (int i = 0; i<trameVdt.length; i++) {
    if (trameVdt[i] == aiguille[0]) {
      int n=0;
      for (int j = 1; j<aiguille.length; j++) {
        if (trameVdt[i+j] == aiguille[j]) {
          n++;
        }
      }
      if (n==aiguille.length-1) {
        indexTemp[k]=i;
        k++;
      }
    }
  }
  int[] index = new int[k];
  for (int i = 0; i<k; i++) {
    index[i] = indexTemp[i];
  }
  return index;
}

void loadTex() {
  selectInput("Choisir le fichier videoTex à charger", "fichierOuvrir");
}

void fichierOuvrir(File selection) {
  if (selection == null) {
    println("Annulation ouvrir fichier");
  } else {
    println("User selected " + selection.getAbsolutePath());
    trameVdt = loadBytes(selection.getAbsolutePath());
    vdtCharge = true;
  }
}

void affTrame(int nC, int premiereLigne , int t, int margeX, int margeY) {
  fill(0);
  textAlign(LEFT, TOP);
  textSize(t);
  float l = t*1.5;
  int iDebut = premiereLigne*nColonnes;
  for (int i = iDebut; i<trameVdt.length; i++) {
    int iDecale = i-iDebut;
    text(hex(trameVdt[i]), l*(iDecale%nC) + margeX, l*(iDecale/nC) + margeY);
    TableRow resultat = codesVdt.findRow(nf(i, 5), 0);
    if (resultat != null) {
      noFill();
      stroke(0, 0, 255);
      rect(l*(iDecale%nC) + margeX, l*(iDecale/nC) + margeY, l*resultat.getInt(2)-5, l-5);
    }
  }
  fill(180);
  noStroke();
  rect(margeX,margeY,nC*l,-l);
  rect(margeX,margeY,-l,height);
  fill(0);
  for (int i = 0 ; i<nC ; i ++){
    text(hex(i,2), l*i + margeX , margeY-l);
  }
  for (int j = premiereLigne ; j<trameVdt.length/nC ; j ++){
    text(hex(j,2), margeX-l, l*(j-premiereLigne) + margeY);
  }
}

void affCharG1(byte caract, byte cText, byte cFond, int x, int y, int w, int h) {
  noStroke();
  int i = 0;
  int[] index = {0, 1, 2, 3, 4, 6}; // le 5 est toujours à 1 
  for (int b = 0; b<=2; b++) {
    for (int a = 0; a <=1; a++) {
      if (bitRead(caract, index[i]) == 0) {
        fill(cFond*36.5); // 36.5 = 255/7 pour que la couleur 7 soit noire
      } else {
        fill(cText*36.5);
      }
      rect(x+a*w/2, y+b*h/3, w/2, h/3+1);
      i++;
    }
  }
  noFill();
  stroke(255, 0, 0);
  rect(x, y, w, h);
  line(x+w/2, y, x+w/2, y+h);
  line(x, y+h/3, x+w, y+h/3);
  line(x, y+2*h/3, x+w, y+2*h/3);
}

int bitRead(byte b, int n) {
  return ( (b / int(pow(2, n)) % 2));
}